<template>
  <a-layout id="components-layout-demo-fixed-sider">
    <a-layout-sider v-model="collapsed" :trigger="null" collapsible width="280">
      <div class="text-center mt-3 mb-3 pl-2 pr-2">
        <img src="@/assets/icon.png" width="55" v-if="collapsed" />
        <img src="@/assets/logo.png" width="110" v-else />
      </div>
      <a-menu theme="light" mode="inline" :default-selected-keys="['1']">
        <a-menu-item v-for="(item, key) in this.items" :key="key">
          <router-link :to="item.path" class="d-flex align-items-center">
            <a-icon :type="item.meta.pageIcon" />
            <span>{{ item.meta.pageName }}</span>
          </router-link>
        </a-menu-item>
      </a-menu>
    </a-layout-sider>
    <a-layout>
      <a-layout-header
        :style="{ position: 'fixed', zIndex: 1, width: '100%' }"
        class="bg-primary text-white shadow-sm"
      >
        <div class="row">
          <div class="w-10">
            <a-icon
              class="trigger"
              :type="collapsed ? 'right' : 'left'"
              @click="() => (collapsed = !collapsed)"
            />
          </div>
          <div class="col d-flex align-items-center">
            <h3 class="h-100 d-flex align-items-center m-0 p-0 text-white">
              {{ this.$route.meta.pageName }}
            </h3>
          </div>
        </div>
      </a-layout-header>
      <a-layout-content class="p-4">
        <div :style="{ padding: '13px', marginTop: '40px' }">
          <div class="row" v-if="this.$route.meta.backPage">
            <div class="col">
              <div class="row">
                <div
                  class="d-flex align-items-center border-right"
                  v-if="this.$route.meta.pageName"
                  style="width: 100px"
                >
                  <a-button
                    type="link"
                    class="text-dark d-flex align-items-center"
                    @click="$router.go(-1)"
                  >
                    <a-icon type="arrow-left" />
                    <span class="ml-2">Voltar</span>
                  </a-button>
                </div>
                <div class="col d-flex align-items-center">
                  {{ constants.PROJECT }}
                </div>
              </div>
            </div>
          </div>
          <div class="mt-4">
            <slot />
          </div>
        </div>
      </a-layout-content>
      <a-layout-footer class="bg-default" :style="{ textAlign: 'center' }">
        M4P ©2020 Manatus Tecnologia
      </a-layout-footer>
      <a-back-top />
      <strong style="color: rgba(64, 64, 64, 0.6)"> </strong>
    </a-layout>
  </a-layout>
</template>

<script>
import Coronavirus from '@/assets/img/background-login.jpg'
import { Constants } from '@/constants/constants'
export default {
  name: 'app',
  created() {
    this.$router.options.routes.forEach((route) => {
      if (route.meta.sideBar) {
        this.items.push({
          path: route.path,
          name: route.name,
          meta: {
            guest: route.meta.guest,
            layout: route.meta.layout,
            pageName: route.meta.pageName,
            pageIcon: route.meta.pageIcon,
            backPage: route.meta.backPage,
            sideBar: route.meta.sideBar,
          },
        })
      }
    })
  },
  data() {
    return {
      collapsed: false,
      constants: Constants,
      coronavirusImage: Coronavirus,
      items: [],
    }
  },
}
</script>

<style>
#components-layout-demo-fixed-sider .logo {
  height: 32px;
  background: rgba(255, 255, 255, 0.2);
  margin: 16px;
}
</style>
